<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.5 of 16. April 2007 on 27. Mai 2010 at 7:15:21</time-stamp>


<methods>
<class-id>Kernel.AbsentClassImporter class</class-id> <category>instance creation</category>

<body package="System-Code Storage" selector="installInSystem">installInSystem
	"Install the receiver in its environment, prior to being reparented via installInParent."

	| systemBinding |
	self isSubclassOfAbsentClass ifFalse:
		[^self shouldNotImplement].

	self absentSuperclassObject isBehavior ifFalse:
		[^self error: (#errSuperClassNotInstalled &lt;&lt; #dialogs &gt;&gt; 'superclass not yet installed')].
	nil == (systemBinding := self environment localBindingFor: binding key)
		ifTrue:
			[self environment addBinding: binding]
		ifFalse:
			[CodeReader classAlreadyLoadedSignal
				raiseWith: name asString
				errorString: name asString, ' : '.
			"The following will correctly merge the two bindings, substituting
			 the receiver as the new value.  If the signal above is made proceedable
			 this may actually be useful."
			self environment at: binding key put: binding value.
			binding oneWayBecome: systemBinding].
	category ~~ nil ifTrue: [self environment organization classify: name under: category].
	self addToSuper</body>
</methods>

</st-source>
